// Particle Environment

class ParticleEnv
{
  ArrayList _particles; 
   
  ParticleEnv()
  {
    _particles = new ArrayList();
  }
   
  void add(Particle part)
  {
    _particles.add(part);
  }
 
  void checkLifetime()
  {
    Iterator particleIter = _particles.iterator(); 
    while( particleIter.hasNext() ) 
    { 
      Particle p = (Particle) particleIter.next(); 
      if(p._curTime >= p._lifeTime)
        // particle dead, delete it from list
        particleIter.remove();
    }   
    
  }
  
  void checkPos(Particle particle)
  {
    // check horiz. pos
    if(particle._pos.x < 0) 
    {
       particle._pos.x = 0;
       particle._dir.x = -particle._dir.x;
    }
    else if(particle._pos.x > width)
    {
       particle._pos.x = width;
       particle._dir.x = -particle._dir.x;
    }
    
    // check vertical pos
    if(particle._pos.y < 0) 
    {
       particle._pos.y = 0;
       particle._dir.y = -particle._dir.y;
    }
    else if(particle._pos.y > height)
    {
       particle._pos.y = height;
       particle._dir.y = -particle._dir.y;
    }  
  }

  void draw(int timePass)
  {
    int i;
    
    // update the position
    for (i = 0; i < _particles.size(); i++) 
    {
      Particle p = (Particle) _particles.get(i);  
      p.update(timePass);
    }
    
    // check for lifeTime
    checkLifetime();

    // check for colision, etc.
    for (i = 0; i < _particles.size(); i++) 
    {
      checkPos((Particle) _particles.get(i));
    }
    
    // draw the hole thing
    for (i = 0; i < _particles.size(); i++) 
    {
      Particle p = (Particle) _particles.get(i);  
      p.draw();
    }
  }
 
}
