// Particles

class Particle
{
  PVector  _pos;
  PVector  _oldPos;
  PVector  _dir;
  float    _dirLength;
  int      _lifeTime;
  int      _curTime;
  float    _normTime;
  
  Particle(PVector pos,PVector dir,int lifeTime)
  {
    _pos = pos.get();
    _oldPos = pos.get(); 
    _dir = dir.get();
    _dirLength = dir.mag();
    _lifeTime = lifeTime;
    _curTime = 0;
  }
  
  void update(float timePass)
  {
    // pos
    _oldPos.set( _pos );
    _pos.add(_dir);

    // lifetime
    _curTime += timePass;
    if(_curTime > _lifeTime)
      _curTime =_lifeTime;
    
    // damping
    //_dir.mult(0.98);

     _normTime = 1.0f - (_curTime * 1.0f / _lifeTime);
    _dir.normalize();
    _dir.mult(_normTime * _dirLength);
    
  }
  
  void draw()
  {
    stroke(255,255,255,255 * _normTime);
    beginShape(LINES);
      vertex(_pos.x,_pos.y);
      vertex(_oldPos.x,_oldPos.y);
    endShape();
  }
  
}
