/* *************************************************************
*  Particle Demo Example
*  Prog. Max Rheiner / IAD / Zhdk
* **************************************************************/

ParticleEnv partEnv;
PVector     partStartPos;
PVector     partEndPos;
int         curTime;

void setup()
{
  size(640, 480);
   
  // create the particle system environment
  partEnv = new ParticleEnv();
  partStartPos = new PVector();
  partEndPos = new PVector();
  
  // get the start time
  curTime = millis();
  smooth();
}

void draw()
{
  background(51); 

  // calc the dif time
  int difTime = millis() - curTime;
  if(difTime > 0)
    curTime = millis();
    
  // draw the particles
  partEnv.draw(difTime);
}

void mousePressed() 
{
  partStartPos.set(mouseX,mouseY,0);
}

void mouseDragged()
{
  partEndPos.set(mouseX,mouseY,0);
  
  // calculate the direction of the particle
  PVector dir = partEndPos;
  dir.sub(partStartPos);
  dir.mult(.05);

  // select the particle type
  if(mouseButton == LEFT)
    partEnv.add( new Particle(partStartPos,dir,8000) );
  else
    partEnv.add( new ParticleFX(partStartPos,
                                dir,
                                (int)random(500,10000),
                                new PVector(random(100,200),random(80,90),random(110,120)),
                                random(3,10)) );
}


